      subroutine ZZ_HZZ_g(p,msq)
      implicit none
c--- Weak Boson Fusion by Z-Z exchange only
c---Matrix element squared averaged over initial colors and spins
c
c     q(-p1)+q(-p2) -->  H(p3,p4)+q(p5)+q(p6)+g(p7)
c                           |
c                           |
c                           |
c                           ---> W+(nu(p3)+e+(p4))+W-(e-(p5)+nub(p6))
      include 'constants.f'
      include 'masses.f'
      include 'ewcouple.f'
      include 'qcdcouple.f'
      include 'zcouple.f'
      include 'sprods_com.f'
      integer j,k,nup,ndo
      double precision p(mxpart,4),facqq,facqg,s3456
      double precision msq(-nf:nf,-nf:nf),hdecay,
     . ud_udg_LL,udb_udbg_LL,ud_udg_LR,udb_udbg_LR,
     . ug_uddb_LL,ug_uddb_LR,gu_ddbu_LL,gu_ddbu_LR

      parameter (nup=2,ndo=3)

      do j=-nf,nf
      do k=-nf,nf
      msq(j,k)=0d0
      enddo
      enddo

      call dotem(9,p,s)

      s3456=s(3,4)+s(3,5)+s(3,6)+s(4,5)+s(4,6)+s(5,6)
      hdecay=gwsq**3*zmass**2*4d0*xw**2/(one-xw)*
     &  (((l1*l2)**2+(r1*r2)**2)*s(3,5)*s(4,6)
     & + ((r1*l2)**2+(r2*l1)**2)*s(3,6)*s(4,5))
      hdecay=hdecay/((s(3,4)-zmass**2)**2+(zmass*zwidth)**2)
      hdecay=hdecay/((s(5,6)-zmass**2)**2+(zmass*zwidth)**2)
      hdecay=hdecay/((s3456-hmass**2)**2+(hmass*hwidth)**2)

      facqq=0.25d0*gsq*Cf*gwsq**3*hdecay
      facqg=-facqq*(aveqg/aveqq)
C Extra factor of gsq*Cf compared to lowest order

C q-q and qbar-qbar
c--- u(1)+d(2) -> u(7)+d(8)+g(p9)
c--- ub(1)+db(2) -> ub(7)+db(8)+g(p9)
      call msq_gpieces_zz(1,2,7,8,9,ud_udg_LL,ud_udg_LR)

C q-qbar and qbar-q
c--- u(1)+db(2) -> u(7)+db(8)+g(p9)
c--- ub(1)+d(2) -> ub(7)+d(8)+g(p9)
      call msq_gpieces_zz(1,8,7,2,9,udb_udbg_LL,udb_udbg_LR)

C q-g and qbar-g
c--- u(1)+g(2) -> u(7)+[q](8)+[qb](9)
c--- ub(1)+g(2) -> ub(7)+[qb](8)+[q](9)
      call msq_gpieces_zz(1,9,7,8,2,ug_uddb_LL,ug_uddb_LR)

C g-q and g-qbar
c--- g(1)+u(2) -> [q](7)+[qb](8)+u(9)
c--- g(1)+ub(2) -> [qb](7)+[q](8)+ub(9)
      call msq_gpieces_zz(8,2,7,9,1,gu_ddbu_LL,gu_ddbu_LR)

      do j=-nf,nf
      do k=-nf,nf
        if     ((j .gt. 0) .and. (k .lt. 0)) then
          msq(j,k)=facqq*(
     .     +udb_udbg_LL*((L(+j)*L(-k))**2+(R(+j)*R(-k))**2)
     .     +udb_udbg_LR*((L(+j)*R(-k))**2+(R(+j)*L(-k))**2))
        elseif ((j .lt. 0) .and. (k .gt. 0)) then
          msq(j,k)=facqq*(
     .     +udb_udbg_LL*((L(-j)*L(k))**2+(R(-j)*R(k))**2)
     .     +udb_udbg_LR*((L(-j)*R(k))**2+(R(-j)*L(k))**2))
        elseif ((j .gt. 0) .and. (k .gt. 0)) then
          msq(j,k)=facqq*(
     .     +ud_udg_LL*((L(+j)*L(+k))**2+(R(+j)*R(+k))**2)
     .     +ud_udg_LR*((L(+j)*R(+k))**2+(R(+j)*L(+k))**2))
        elseif ((j .lt. 0) .and. (k .lt. 0)) then
          msq(j,k)=facqq*(
     .     +ud_udg_LL*((L(-j)*L(-k))**2+(R(-j)*R(-k))**2)
     .     +ud_udg_LR*((L(-j)*R(-k))**2+(R(-j)*L(-k))**2))
        elseif ((j .ne. 0) .and. (k .eq. 0)) then
          msq(j,k)=facqg*dfloat(nup)*(
     .     +ug_uddb_LL*((L(abs(j))*L(+2))**2+(R(abs(j))*R(+2))**2)
     .     +ug_uddb_LR*((L(abs(j))*R(+2))**2+(R(abs(j))*L(+2))**2))
     .            +facqg*dfloat(ndo)*(
     .     +ug_uddb_LL*((L(abs(j))*L(+1))**2+(R(abs(j))*R(+1))**2)
     .     +ug_uddb_LR*((L(abs(j))*R(+1))**2+(R(abs(j))*L(+1))**2))
        elseif ((j .eq. 0) .and. (k .ne. 0)) then
          msq(j,k)=facqg*dfloat(nup)*(
     .     +gu_ddbu_LL*((L(abs(k))*L(+2))**2+(R(abs(k))*R(+2))**2)
     .     +gu_ddbu_LR*((L(abs(k))*R(+2))**2+(R(abs(k))*L(+2))**2))
     .            +facqg*dfloat(ndo)*(
     .     +gu_ddbu_LL*((L(abs(k))*L(+1))**2+(R(abs(k))*R(+1))**2)
     .     +gu_ddbu_LR*((L(abs(k))*R(+1))**2+(R(abs(k))*L(+1))**2))
        endif
      enddo
      enddo

      return
      end


